#include <iostream>
#include <tiffio.h>
#include <cmath>
#include <cstdlib>
#include <sstream>
#include <cstdio>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "float.h"
#include "mpi.h"
#include "time.h"
using namespace std;

#define kansoku (8)
#define kensa (16)
#define kensa_z (0)
#define kouho (5)
#define kouho_z (0)
#define kensa_num (3)
#define db_del (1.0)
#define del (1)
#define def_tate (249)
#define def_yoko (301)
#define def_takasa (41)
#define TOTFILENAME (10000)
#define MAX_CHAR_NUM (256)
#define OTHER_FILE_NUM (2)
#define sentou_file_num (848)
int Rec_Kensa[kensa_num];
int Rec_KensaZ[kensa_num];
int Sibori_Kensa[kensa_num];
int Sibori_KensaZ[kensa_num];
int Cento_x[kensa_num+1];
int Cento_y[kensa_num+1];
int Cento_z[kensa_num+1];
double g_u;
double g_v;
double g_w;
int out[def_takasa][def_tate][def_yoko];
int out2[def_takasa][def_tate][def_yoko];
char FILENAME[TOTFILENAME][MAX_CHAR_NUM];
int win_h;
int win_w;
int win_d;
int im_h = def_tate;
int im_w = def_yoko;
int im_d = def_takasa;
int sta_x;
int sta_y;
int sta_z;
class Matching{
	public:
	 double correlation(int y,int x ,int tate,int yoko,int **f, int ** g,int kurikaeshi);
	void correlation2(int y,int x ,int vec_v,int vec_u,int **f, int ** g);
	double FINAL_correlation(int z, int y, int x , int takasa, int tate, int yoko, int kurikaeshi);
	void FINAL_correlation2(int z, int y,int x, int vec_w, int vec_v,int vec_u);
	
};
int main(int argc, char* argv[]){
	int r=0;
	int rows=0;
	int columns;
	uint16 BitsPerSample;
	uint16 SamplesPerPixels;
	uint16 PhotoMetric;
	uint32 TifSize;
	uint16 *in_image;
	uint16 *in_image2;
	TIFF *in_filep;
	TIFF *in_filep2;
	int check_io;
	char infile[MAX_CHAR_NUM];
	char infile2[MAX_CHAR_NUM];
	char outfile[MAX_CHAR_NUM];
	int n1, n2, n3, n4;
	int i,j;
	FILE *fp;
	Matching mat;
	DIR* dir;
	struct dirent* dp;
	int count_file = 0;
	char dirname[MAX_CHAR_NUM] = "/home/akkimura/PIV_data/02emb04left00cort/";
	int my_rank;
	int n_proc;
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &n_proc);
	time_t pre_time;
	time_t post_time;
	if( my_rank == 0){
		pre_time = time((time_t *)0);
	}

	dir = opendir(dirname);
	if(dir==NULL){
		printf("unko\n");
		exit(0);
	}
		for(i = 0; NULL != (dp = readdir(dir)); i++){
			strcpy(FILENAME[i],dp->d_name);
//		if(i<10){
//			printf("%s %d\n",FILENAME[i],i);
//			}
			count_file++;
		}
		char temp[MAX_CHAR_NUM];
		for(i =0; i < count_file-1; i++){
			for(j = i+1; j < count_file; j++){
				if ((strcmp(FILENAME[j],FILENAME[i])) < 0){
					strcpy(temp,FILENAME[i]);
					strcpy(FILENAME[i],FILENAME[j]);
					strcpy(FILENAME[j],temp);
				}
			}
		}
	MPI_Barrier(MPI_COMM_WORLD);
	printf("count_file %d rank %d proc %d\n",count_file,my_rank,n_proc);
	printf("%s\n",FILENAME[count_file-1]);
	int kurikaeshi = 0;
	MPI_Barrier(MPI_COMM_WORLD);
	int m1,m2,m3,m4;
	for(kurikaeshi = 0; kurikaeshi < 9; kurikaeshi++){
		//n1,n2,n3 specify the file number
		//n1,n2,n3
		int  x, y,z;
		//loop for data allocation 
		int slice_tot;
		int slice;
		infile[0] = '\0';
		infile2[0] = '\0';
		int file_num = kurikaeshi*n_proc+my_rank; 
		
		if(file_num<count_file-4){
			strcpy(infile, dirname);
			strcat(infile, FILENAME[kurikaeshi*n_proc+my_rank+2]);
			cout << infile << endl;
			in_filep = TIFFOpen(infile, "r");
			if (in_filep == NULL) {
				cout << "could not open input file" << endl;
			}
			slice_tot = TIFFNumberOfDirectories(in_filep);
			TIFFGetField(in_filep, TIFFTAG_IMAGELENGTH, &rows);
			TIFFGetField(in_filep, TIFFTAG_IMAGEWIDTH, &columns);
			TIFFGetField(in_filep, TIFFTAG_BITSPERSAMPLE, &BitsPerSample);
			TIFFGetField(in_filep, TIFFTAG_SAMPLESPERPIXEL, &SamplesPerPixels);
			TIFFGetField(in_filep, TIFFTAG_PHOTOMETRIC, &PhotoMetric);
			if(my_rank==0){
				printf("rows = %d\n", rows);
				printf("columns = %d\n", columns);
				printf("BitsPerSample = %d\n", BitsPerSample);
				printf("SamplesPerPixel = %d\n", SamplesPerPixels);
				printf("PhotoMetric = %d\n", PhotoMetric);
			}
			TifSize = rows* columns * sizeof( uint16 ); 
			in_image = ( uint16 *) malloc(TifSize);
			if (in_image == NULL) {
				cout << "could not alloctate memory" << endl;
			}
			for(slice = 0; slice < slice_tot; slice++){
				if ( ! TIFFSetDirectory( in_filep, slice ) ){
					printf("ERROR: Can not set TIFF directory [TIFFSetDirectory] \n");
					exit( EXIT_FAILURE );
				}

				for (r = 0; r <(int)rows; r++) {
					check_io = TIFFReadScanline(in_filep, &in_image[r*columns], r, 1);
					if (check_io != 1){
						cout<< "not read image from files" << endl;
					}
				}

				for (y=0;y<(int)rows; y++){
					for (x=0;x<(int)columns;x++){
						out[slice][y][x]=in_image[y*columns+x];
					}
				}
			}
		
			_TIFFfree(in_image);
			TIFFClose(in_filep);
		}
		MPI_Barrier(MPI_COMM_WORLD);	
		if(file_num<count_file-4){
			strcpy(infile2, dirname);
			strcat(infile2,FILENAME[file_num+2+1]);
			cout << infile2 << endl;
			in_filep2 = TIFFOpen(infile2, "r");
			if (in_filep2 == NULL) {
				cout << "could not open input file" << endl;
			}
			in_image2 = ( uint16 *)malloc(TifSize);
			if (in_image2 == NULL) {
				cout << "could not alloctate memory" << endl;
			}
			for(slice = 0; slice < slice_tot; slice++){
				if ( ! TIFFSetDirectory( in_filep2, slice ) ){
					printf("ERROR: Can not set TIFF directory [TIFFSetDirectory] \n");
					exit( EXIT_FAILURE );
				}
				for (r = 0; r <rows; r++) {
					check_io = TIFFReadScanline(in_filep2, &in_image2[r*columns], r, 1);
					if (check_io != 1){
						cout<< "not read image from files" << endl;
					}
				}
				for (y = 0;y < (int)rows; y++){
					for (x = 0;x < (int)columns;x++){
						out2[slice][y][x]=(int)in_image2[y*columns+x];
					}
				}
			}
			_TIFFfree(in_image2);
			TIFFClose(in_filep2);
		}
		MPI_Barrier(MPI_COMM_WORLD);
		if(file_num<count_file-4){
			int file_num_from_start1 = file_num + sentou_file_num;
			int file_num_from_start2 = file_num + sentou_file_num + 1;
			m1=file_num_from_start1/1000;
			m2=file_num_from_start1/100-m1*10;
			m3=file_num_from_start1/10-m1*100-m2*10;
			m4=file_num_from_start1-m1*1000-m2*100-m3*10;
			n1=file_num_from_start2/1000;
			n2=file_num_from_start2/100-n1*10;
			n3=file_num_from_start2/10-n1*100-n2*10;
			n4=file_num_from_start2-n1*1000-n2*100-n3*10;
			
			sprintf(outfile,"130321_3DPIV_WORM02_EMB04_LEFT00_param3_cyto%d%d%d%dTO%d%d%d%d.txt",m1,m2,m3,m4,n1,n2,n3,n4);
			fp=fopen(outfile,"w");
			cout << "Read multi-tiff done" <<endl;
				//setting for recursive correlation
				//KensaRyoiki dekasa
			Rec_Kensa[0] = kensa;
			Rec_Kensa[1] = 14;
			Rec_Kensa[2] = 12;
			Rec_KensaZ[0] = kensa_z;
			Rec_KensaZ[1] = 0;
			Rec_KensaZ[2] = 0;
				//KouhoRyoiki dekasa
			Sibori_Kensa[0] = kouho;
			Sibori_Kensa[1] = 2;
			Sibori_Kensa[2]	= 1;
			Sibori_KensaZ[0] = kouho_z;
			Sibori_KensaZ[1] = 1;
			Sibori_KensaZ[2] = 0;
				//Centor
			Cento_x[0] = 0;
			Cento_y[0] = 0;
			Cento_z[0] = 0;
			for (z = kensa_z; z < def_takasa-kensa_z; z++){
				for (y = kensa;y < (int)rows-kensa; y += kansoku){
					for (x = kensa;x < (int)columns-kensa; x += kansoku){
						if(z-del-kensa_z < 0)continue;
						if(z+2*del+kensa_z > def_takasa-1) continue;
						if(y-del < 0)continue;
						if(y+2*del > rows-1)continue;
						if(x-del < 0)continue;
						if(x+2*del > columns-1)continue;
						double maxsoukan=-1000.0;
						double soukan;
						int yokokun, tatekun, takasakun;
						int vector_u, vector_v, vector_w;
						int kensa_ind;
						Cento_x[0] = x;
						Cento_y[0] = y;
						Cento_z[0] = z;
						for(kensa_ind = 0; kensa_ind < kensa_num; kensa_ind++){
							maxsoukan =-1000.0;
							vector_u=0;
							vector_v=0;
							vector_w=0;
							for (takasakun = Cento_z[kensa_ind]-Sibori_KensaZ[kensa_ind];takasakun <=Cento_z[kensa_ind]+Sibori_KensaZ[kensa_ind];takasakun++){
								for (tatekun = Cento_y[kensa_ind]-Sibori_Kensa[kensa_ind];tatekun <= Cento_y[kensa_ind]+Sibori_Kensa[kensa_ind];tatekun++){
									for (yokokun = Cento_x[kensa_ind]-Sibori_Kensa[kensa_ind];yokokun <= Cento_x[kensa_ind]+Sibori_Kensa[kensa_ind];yokokun++){
										if(takasakun-kensa_z-del < 0)continue;
										if(takasakun+kensa_z+2*del > def_takasa-1) continue;
										if(tatekun-kensa < 0)continue;
										if(tatekun+kensa > rows-1)continue;
										if(yokokun-kensa < 0)continue;
										if(yokokun+kensa > columns-1)continue;
										if(takasakun-del < 0)continue;
										if(takasakun+2*del > def_takasa-1) continue;
										if(tatekun-del < 0)continue;
										if(tatekun+2*del > rows-1)continue;
										if(yokokun-del < 0)continue;
										if(yokokun+2*del > columns-1)continue;
										soukan = mat.FINAL_correlation(z,y,x,takasakun,tatekun,yokokun,kensa_ind);
										if(soukan>maxsoukan){
											vector_w = takasakun-z;
											vector_u = yokokun-x;
											vector_v = tatekun-y;
											maxsoukan = soukan;
										}	
									}
								}
							}
							Cento_x[kensa_ind+1] = x + vector_u;
							Cento_y[kensa_ind+1] = y + vector_v;
							Cento_z[kensa_ind+1] = z + vector_w;
						}
						mat.FINAL_correlation2(z,y,x,vector_w,vector_v,vector_u);
						double db_vector_u = (double)vector_u;
						double db_vector_v = (double)vector_v;
						double db_vector_w = (double)vector_w;
						db_vector_u += g_u;
						db_vector_v += g_v;
						db_vector_w += g_w;
						fprintf(fp,"%d %d %d %f %f %f %f %f %f\n",x,y,z,db_vector_u,db_vector_v,db_vector_w,g_u,g_v,g_w);
					}	
				}
			}
		}
		MPI_Barrier(MPI_COMM_WORLD);
		
		fclose(fp);	
		printf("sdaad\n");
	}
	if(my_rank ==0){
		post_time = time((time_t *)0);
		printf("diff_time%f \n",difftime(post_time,pre_time));
	}
	MPI_Barrier(MPI_COMM_WORLD);
        MPI_Finalize();
        return 0;
}	
	
double Matching::correlation(int y,int x ,int tate,int yoko,int **f, int ** g,int kurikaeshi){
	int i,j;
	double fmean = 0;
	double gmean = 0;
	double fdev = 0;
	double gdev = 0;
	double fgcor = 0;
	double rvalue;
	for(i = y-Rec_Kensa[kurikaeshi];i <= y+Rec_Kensa[kurikaeshi];i++){
		for(j = x-Rec_Kensa[kurikaeshi];j <= x+Rec_Kensa[kurikaeshi];j++){
			fmean += (double)f[i][j];
		}
	}
	for(i = tate-Rec_Kensa[kurikaeshi];i <= tate+Rec_Kensa[kurikaeshi];i++){
		for(j = yoko-Rec_Kensa[kurikaeshi];j <= yoko+Rec_Kensa[kurikaeshi];j++){
			gmean += (double)g[i][j];
		}
	}
	fmean/=(double)((2.0*Rec_Kensa[kurikaeshi]+1.0)*(2.0*Rec_Kensa[kurikaeshi]+1.0));
	gmean/=(double)((2.0*Rec_Kensa[kurikaeshi]+1.0)*(2.0*Rec_Kensa[kurikaeshi]+1.0));
	for(i = y - Rec_Kensa[kurikaeshi];i <= y + Rec_Kensa[kurikaeshi];i++){
		for(j = x - Rec_Kensa[kurikaeshi]; j <= x + Rec_Kensa[kurikaeshi]; j++){
			fdev  += ((double)f[i][j] - (double)fmean) * ((double)f[i][j] - (double)fmean);
			gdev  += ((double)g[i-y+tate][j-x+yoko] - (double)gmean) * ((double)g[i-y+tate][j-x+yoko] - (double)gmean);
			fgcor += ((double)f[i][j] - (double)fmean) * ((double)g[i-y+tate][j-x+yoko] - (double)gmean);
		
		}
	}
	fdev = sqrt(fdev);
	gdev = sqrt(gdev);
	if(fdev==0||gdev==0){
		return 0.0;
	}
	
	rvalue = fgcor/(fdev*gdev);
	return rvalue;
}
void Matching::correlation2(int y,int x ,int vec_v,int vec_u,int **f, int ** g){
	int i,j;
	double xdiff;
	double ydiff;
	double tdiff;
	double a,b,c;
	double p,q;
	a = 0.0;
	b = 0.0;
	c = 0.0;
	p = 0.0;
	q = 0.0;
	for(i = y-Rec_Kensa[kensa_num-1];i <= y+Rec_Kensa[kensa_num-1];i++){
		for(j = x-Rec_Kensa[kensa_num-1];j <= x+Rec_Kensa[kensa_num-1];j++){
			xdiff = (-1.0*f[i][j+2*del]+6.0*f[i][j+del]-3.0*f[i][j]-2.0*f[i][j-del])/(6.0*db_del);
			xdiff += (-1.0*g[i+vec_v][j+2*del+vec_u]+6.0*g[i+vec_v][j+del+vec_u]-3.0*g[i+vec_v][j+vec_u]-2.0*g[i+vec_v][j-del+vec_u])/(6.0*db_del);
			xdiff /= 2.0;
			ydiff = (-1.0*f[i+2*del][j]+6.0*f[i+del][j]-3.0*f[i][j]-2.0*f[i-del][j])/(6.0*db_del);
			ydiff += (-1.0*g[i+2*del+vec_v][j+vec_u] + 6.0*g[i+del+vec_v][j+vec_u] - 3.0*g[i+vec_v][j+vec_v] - 2.0*g[i-del+vec_v][j+vec_u])/(6.0*db_del);
			ydiff /= 2.0;
			tdiff =g[i+vec_v][j+vec_u]-f[i][j];
			
			a += xdiff*xdiff;
			b += xdiff*ydiff;
			c += ydiff*ydiff;
			p -= xdiff*tdiff;
			q -= ydiff*tdiff;	
		}
	}
	g_u = (c*p-b*q)/(a*c-b*b);
	g_v = (-p*b+a*q)/(a*c-b*b);
}

double Matching::FINAL_correlation(int z, int y, int x , int takasa, int tate, int yoko, int kurikaeshi){
	int i,j,k;
	double fmean = 0;
	double gmean = 0;
	double fdev = 0;
	double gdev = 0;
	double fgcor = 0;
	double rvalue;
	for(k = z-Rec_KensaZ[kurikaeshi]; k <= z+Rec_KensaZ[kurikaeshi];k++){ 
		for(i = y-Rec_Kensa[kurikaeshi];i <= y+Rec_Kensa[kurikaeshi];i++){
			for(j = x-Rec_Kensa[kurikaeshi];j <= x+Rec_Kensa[kurikaeshi];j++){
				fmean += (double)out[k][i][j];
			}
		}
	}
	for(k = takasa-Rec_KensaZ[kurikaeshi]; k <= takasa+Rec_KensaZ[kurikaeshi];k++){
		for(i = tate-Rec_Kensa[kurikaeshi];i <= tate+Rec_Kensa[kurikaeshi];i++){
			for(j = yoko-Rec_Kensa[kurikaeshi];j <= yoko+Rec_Kensa[kurikaeshi];j++){
				gmean += (double)out2[k][i][j];
			}
		}
	}
	fmean/=(double)((2.0*Rec_KensaZ[kurikaeshi]+1.0)*(2.0*Rec_Kensa[kurikaeshi]+1.0)*(2.0*Rec_Kensa[kurikaeshi]+1.0));
	gmean/=(double)((2.0*Rec_KensaZ[kurikaeshi]+1.0)*(2.0*Rec_Kensa[kurikaeshi]+1.0)*(2.0*Rec_Kensa[kurikaeshi]+1.0));
	for(k = z - Rec_KensaZ[kurikaeshi]; k <= z + Rec_KensaZ[kurikaeshi];k++){
		for(i = y - Rec_Kensa[kurikaeshi];i <= y + Rec_Kensa[kurikaeshi];i++){
			for(j = x - Rec_Kensa[kurikaeshi]; j <= x + Rec_Kensa[kurikaeshi]; j++){
				fdev  += ((double)out[k][i][j] - (double)fmean) * ((double)out[k][i][j] - (double)fmean);
				gdev  += ((double)out2[k-z+takasa][i-y+tate][j-x+yoko] - (double)gmean) * ((double)out2[k-z+takasa][i-y+tate][j-x+yoko] - (double)gmean);
				fgcor += ((double)out[k][i][j] - (double)fmean) * ((double)out2[k-z+takasa][i-y+tate][j-x+yoko] - (double)gmean);
			}
		}
	}
	fdev = sqrt(fdev);
	gdev = sqrt(gdev);
	if(fdev==0||gdev==0){
		return 0.0;
	}
	
	rvalue = fgcor/(fdev*gdev);
	return rvalue;
}
void Matching::FINAL_correlation2(int z, int y,int x, int vec_w, int vec_v,int vec_u){
	int i,j,k;
	double xdiff;
	double ydiff;
	double zdiff;
	double tdiff;
	double a[3][3];
	double b[3];
	double det;
	for(i = 0; i < 3; i++){
		b[i] = 0.0;
		for(j = 0; j < 3; j++){
			a[i][j] = 0.0;
		}
	}
	for(k = z-Rec_KensaZ[kensa_num-1]; k <= z+Rec_KensaZ[kensa_num-1];k++){
		for(i = y-Rec_Kensa[kensa_num-1];i <= y+Rec_Kensa[kensa_num-1];i++){
			for(j = x-Rec_Kensa[kensa_num-1];j <= x+Rec_Kensa[kensa_num-1];j++){
				xdiff = (-1.0*out[k][i][j+2*del]+6.0*out[k][i][j+del]-3.0*out[k][i][j]-2.0*out[k][i][j-del])/(6.0*db_del);
				xdiff += (-1.0*out2[k+vec_w][i+vec_v][j+2*del+vec_u]+6.0*out2[k+vec_w][i+vec_v][j+del+vec_u]-3.0*out2[k+vec_w][i+vec_v][j+vec_u]-2.0*out2[k+vec_w][i+vec_v][j-del+vec_u])/(6.0*db_del);
				xdiff /= 2.0;
				ydiff = (-1.0*out[k][i+2*del][j]+6.0*out[k][i+del][j]-3.0*out[k][i][j]-2.0*out[k][i-del][j])/(6.0*db_del);
				ydiff += (-1.0*out2[k+vec_w][i+2*del+vec_v][j+vec_u]+6.0*out2[k+vec_w][i+del+vec_v][j+vec_u]-3.0*out2[k+vec_w][i+vec_v][j+vec_u]-2.0*out2[k+vec_w][i-del+vec_v][j+vec_u])/(6.0*db_del);
				ydiff /= 2.0;
				zdiff = (-1.0*out[k+2*del][i][j]+6.0*out[k+del][i][j]-3.0*out[k][i][j]-2.0*out[k-del][i][j])/(6.0*db_del);
				zdiff += (-1.0*out2[k+vec_w+2*del][i+vec_v][j+vec_u]+6.0*out2[k+vec_w+del][i+vec_v][j+vec_u]-3.0*out2[k+vec_w][i+vec_v][j+vec_u]-2.0*out2[k+vec_w-del][i+vec_v][j+vec_u])/(6.0*db_del);
				zdiff /= 2.0;
				tdiff =out2[k+vec_w][i+vec_v][j+vec_u]-out[k][i][j];	
				a[0][0] += xdiff*xdiff;
				a[1][1] += ydiff*ydiff;
				a[2][2] += zdiff*zdiff;
				a[0][1] += xdiff*ydiff;
				a[1][0] += ydiff*xdiff;
				a[0][2] += xdiff*zdiff;
				a[2][0] += zdiff*xdiff;
				a[1][2] += ydiff*zdiff;
				a[2][1] += zdiff*ydiff;
				b[0] -= xdiff*tdiff;
				b[1] -= ydiff*tdiff;
				b[2] -= zdiff*tdiff;
			}
		}
	}
	det = (a[0][0]*a[1][1]*a[2][2]+a[1][0]*a[2][1]*a[0][2]+a[2][0]*a[0][1]*a[1][2]-a[0][0]*a[1][2]*a[2][1]-a[1][0]*a[2][2]*a[0][1]-a[2][0]*a[0][2]*a[1][1]);
	if(det != 0){
		g_u = (b[0]*a[1][1]*a[2][2]+b[1]*a[2][1]*a[0][2]+b[2]*a[0][1]*a[1][2]-b[0]*a[1][2]*a[2][1]-b[1]*a[2][2]*a[0][1]-b[2]*a[0][2]*a[1][1])/(det);
		g_v = (a[0][0]*b[1]*a[2][2]+a[1][0]*b[2]*a[0][2]+a[2][0]*b[0]*a[1][2]-a[0][0]*a[1][2]*b[2]-a[1][0]*a[2][2]*b[0]-a[2][0]*a[0][2]*b[1])/(det);
		g_w = (a[0][0]*a[1][1]*b[2]+a[1][0]*a[2][1]*b[0]+a[2][0]*a[0][1]*b[1]-a[0][0]*b[1]*a[2][1]-a[1][0]*b[2]*a[0][1]-a[2][0]*b[0]*a[1][1])/det;
	}
	else{
		g_u = 0.0;
		g_v = 0.0;
		g_w = 0.0;
	}

}



